/*
 * Front gateway
 *
 * Front gateway
 *
 * API version: 0.0.1
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"encoding/json"
	"net/http"
	"strings"

	
)

// AuthApiController binds http requests to an api service and writes the service results to the http response
type AuthApiController struct {
	service AuthApiServicer
	errorHandler ErrorHandler
}

// AuthApiOption for how the controller is set up.
type AuthApiOption func(*AuthApiController)

// WithAuthApiErrorHandler inject ErrorHandler into controller
func WithAuthApiErrorHandler(h ErrorHandler) AuthApiOption {
	return func(c *AuthApiController) {
		c.errorHandler = h
	}
}

// NewAuthApiController creates a default api controller
func NewAuthApiController(s AuthApiServicer, opts ...AuthApiOption) Router {
	controller := &AuthApiController{
		service:      s,
		errorHandler: DefaultErrorHandler,
	}

	for _, opt := range opts {
		opt(controller)
	}

	return controller
}

// Routes returns all of the api route for the AuthApiController
func (c *AuthApiController) Routes() Routes {
	return Routes{ 
		{
			"AuthConfirmUserPost",
			strings.ToUpper("Post"),
			"/auth/confirm-user",
			c.AuthConfirmUserPost,
		},
		{
			"AuthProlongSessionPost",
			strings.ToUpper("Post"),
			"/auth/prolong-session",
			c.AuthProlongSessionPost,
		},
		{
			"AuthSignInPost",
			strings.ToUpper("Post"),
			"/auth/sign-in",
			c.AuthSignInPost,
		},
		{
			"AuthSignUpPost",
			strings.ToUpper("Post"),
			"/auth/sign-up",
			c.AuthSignUpPost,
		},
	}
}

// AuthConfirmUserPost - 
func (c *AuthApiController) AuthConfirmUserPost(w http.ResponseWriter, r *http.Request) {
	confirmArgsParam := ConfirmArgs{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&confirmArgsParam); err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertConfirmArgsRequired(confirmArgsParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.AuthConfirmUserPost(r.Context(), confirmArgsParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)

}

// AuthProlongSessionPost - 
func (c *AuthApiController) AuthProlongSessionPost(w http.ResponseWriter, r *http.Request) {
	prolongSessionArgsParam := ProlongSessionArgs{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&prolongSessionArgsParam); err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertProlongSessionArgsRequired(prolongSessionArgsParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.AuthProlongSessionPost(r.Context(), prolongSessionArgsParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)

}

// AuthSignInPost - 
func (c *AuthApiController) AuthSignInPost(w http.ResponseWriter, r *http.Request) {
	signInArgsParam := SignInArgs{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&signInArgsParam); err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertSignInArgsRequired(signInArgsParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.AuthSignInPost(r.Context(), signInArgsParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)

}

// AuthSignUpPost - 
func (c *AuthApiController) AuthSignUpPost(w http.ResponseWriter, r *http.Request) {
	signUpArgsParam := SignUpArgs{}
	d := json.NewDecoder(r.Body)
	d.DisallowUnknownFields()
	if err := d.Decode(&signUpArgsParam); err != nil {
		c.errorHandler(w, r, &ParsingError{Err: err}, nil)
		return
	}
	if err := AssertSignUpArgsRequired(signUpArgsParam); err != nil {
		c.errorHandler(w, r, err, nil)
		return
	}
	result, err := c.service.AuthSignUpPost(r.Context(), signUpArgsParam)
	// If an error occurred, encode the error with the status code
	if err != nil {
		c.errorHandler(w, r, err, &result)
		return
	}
	// If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)

}
